<template>
    <a-drawer
        :title="formData.id ? '编辑视频配置' : '增加视频配置'"
        :width="600"
        :visible="visible"
        :destroy-on-close="true"
        :footer-style="{ textAlign: 'right' }"
        @close="onClose"
    >
        <a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-form-item label="设备区域：" name="videoArea">
				<!--<a-input v-model:value="formData.videoArea" placeholder="请输入设备区域" allow-clear />-->
				<a-select v-model:value="formData.videoArea" placeholder="请选择设备区域"
						  :options="areaList"
				> </a-select>
			</a-form-item>
            <a-form-item label="设备名称：" name="videoName">
                <a-input v-model:value="formData.videoName" placeholder="请输入设备名称" allow-clear />
            </a-form-item>
            <a-form-item label="设备序列号：" name="serial">
                <a-input v-model:value="formData.serial" placeholder="请输入设备序列号" allow-clear />
            </a-form-item>
            <a-form-item label="设备通道号：" name="channelNo">
                <a-input v-model:value="formData.channelNo" placeholder="请输入设备通道号" allow-clear />
            </a-form-item>
        </a-form>
        <template #footer>
            <a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
            <a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
        </template>
    </a-drawer>
</template>

<script setup name="bizVideoForm">
    import { cloneDeep } from 'lodash-es'
    import { required } from '@/utils/formRules'
    import bizVideoApi from '@/api/biz/bizVideoApi'
	import bizAreaApi from '@/api/biz/bizAreaApi'
    // 抽屉状态
    const visible = ref(false)
    const emit = defineEmits({ successful: null })
    const formRef = ref()
    // 表单数据
    const formData = ref({})
    const submitLoading = ref(false)
	const areaList = ref()

    // 打开抽屉
    const onOpen = (record) => {
        visible.value = true
        if (record) {
            let recordData = cloneDeep(record)
            formData.value = Object.assign({}, recordData)
        }
		bizAreaApi.bizAreaList().then((res)=>{
			areaList.value = res.map((item)=>{
				return{
					value:item.id,
					label:item.areaName
				}
			})
		})
    }
    // 关闭抽屉
    const onClose = () => {
        formRef.value.resetFields()
        formData.value = {}
        visible.value = false
    }
    // 默认要校验的
    const formRules = {
        videoName: [required('请输入设备名称')],
        videoArea: [required('请选择设备区域')],
        serial: [required('请输入设备序列号')],
        channelNo: [required('请输入设备通道号')],
    }
    // 验证并提交数据
    const onSubmit = () => {
        formRef.value
            .validate()
            .then(() => {
                submitLoading.value = true
                const formDataParam = cloneDeep(formData.value)
                bizVideoApi
                    .bizVideoSubmitForm(formDataParam, !formDataParam.id)
                    .then(() => {
                        onClose()
                        emit('successful')
                    })
                    .finally(() => {
                        submitLoading.value = false
                    })
            })
    }
    // 抛出函数
    defineExpose({
        onOpen
    })
</script>
